diff --git a/tests/data/config_complete.ast b/tests/data/config_complete.ast
new file mode 100644
index 0000000..76c4593
--- /dev/null
+++ b/tests/data/config_complete.ast
@@ -0,0 +1,1035 @@
+(lp1
+(lp2
+(dp3
+S'line'
+p4
+I1
+sS'type'
+p5
+S'obj'
+p6
+sS'col'
+p7
+I1
+sS'key'
+p8
+(S'storage'
+S'fileio'
+tp9
+sa(dp10
+g4
+I1
+sg5
+g6
+sg7
+I16
+sg8
+(S'disk'
+S'disk1'
+tp11
+sa(dp12
+S'statements'
+p13
+(lp14
+(lp15
+(dp16
+g4
+I2
+sg5
+S'attr'
+p17
+sg7
+I5
+sg8
+(S'path'
+S'/tmp/disk1.img'
+tp18
+saa(lp19
+(dp20
+g4
+I3
+sg5
+g17
+sg7
+I5
+sg8
+(S'size'
+S'1MB'
+tp21
+saa(lp22
+(dp23
+g4
+I5
+sg5
+S'group'
+p24
+sg7
+I5
+sg8
+(S'attribute'
+tp25
+sa(dp26
+g13
+(lp27
+(lp28
+(dp29
+g4
+I6
+sg5
+g17
+sg7
+I9
+sg8
+(S'block_size'
+S'512'
+tp30
+saa(lp31
+(dp32
+g4
+I7
+sg5
+g17
+sg7
+I9
+sg8
+(S'optimal_sectors'
+S'1024'
+tp33
+saa(lp34
+(dp35
+g4
+I8
+sg5
+g17
+sg7
+I9
+sg8
+(S'queue_depth'
+S'32'
+tp36
+saa(lp37
+(dp38
+g4
+I10
+sg5
+g17
+sg7
+I9
+sg8
+(S'emulate_tas'
+S'yes'
+tp39
+saa(lp40
+(dp41
+g4
+I11
+sg5
+g17
+sg7
+I9
+sg8
+(S'enforce_pr_isids'
+S'yes'
+tp42
+saa(lp43
+(dp44
+g4
+I13
+sg5
+g17
+sg7
+I9
+sg8
+(S'emulate_dpo'
+S'no'
+tp45
+saa(lp46
+(dp47
+g4
+I14
+sg5
+g17
+sg7
+I9
+sg8
+(S'emulate_tpu'
+S'no'
+tp48
+saa(lp49
+(dp50
+g4
+I15
+sg5
+g17
+sg7
+I9
+sg8
+(S'is_nonrot'
+S'no'
+tp51
+saasg4
+I5
+sg5
+S'block'
+p52
+sg7
+I15
+saasg4
+I1
+sg5
+g52
+sg7
+I27
+saa(lp53
+(dp54
+g4
+I19
+sg5
+g6
+sg7
+I1
+sg8
+(S'storage'
+S'fileio'
+tp55
+sa(dp56
+g4
+I19
+sg5
+g6
+sg7
+I16
+sg8
+(S'disk'
+S'disk2'
+tp57
+sa(dp58
+g13
+(lp59
+(lp60
+(dp61
+g4
+I20
+sg5
+g17
+sg7
+I5
+sg8
+(S'path'
+S'/tmp/disk2.img'
+tp62
+saa(lp63
+(dp64
+g4
+I21
+sg5
+g17
+sg7
+I5
+sg8
+(S'size'
+S'1M'
+tp65
+saa(lp66
+(dp67
+g4
+I22
+sg5
+g24
+sg7
+I5
+sg8
+(S'attribute'
+tp68
+sa(dp69
+g4
+I22
+sg5
+g17
+sg7
+I15
+sg8
+(S'block_size'
+S'512'
+tp70
+saa(lp71
+(dp72
+g4
+I23
+sg5
+g24
+sg7
+I5
+sg8
+(S'attribute'
+tp73
+sa(dp74
+g4
+I23
+sg5
+g17
+sg7
+I15
+sg8
+(S'optimal_sectors'
+S'1024'
+tp75
+saa(lp76
+(dp77
+g4
+I24
+sg5
+g24
+sg7
+I5
+sg8
+(S'attribute'
+tp78
+sa(dp79
+g4
+I24
+sg5
+g17
+sg7
+I15
+sg8
+(S'queue_depth'
+S'32'
+tp80
+saasg4
+I19
+sg5
+g52
+sg7
+I27
+saa(lp81
+(dp82
+g4
+I28
+sg5
+g6
+sg7
+I1
+sg8
+(S'fabric'
+S'iscsi'
+tp83
+sa(dp84
+g4
+I28
+sg5
+g24
+sg7
+I14
+sg8
+(S'discovery_auth'
+tp85
+sa(dp86
+g13
+(lp87
+(lp88
+(dp89
+g4
+I29
+sg5
+g17
+sg7
+I5
+sg8
+(S'enable'
+S'yes'
+tp90
+saa(lp91
+(dp92
+g4
+I30
+sg5
+g17
+sg7
+I5
+sg8
+(S'userid'
+S'target1'
+tp93
+saa(lp94
+(dp95
+g4
+I31
+sg5
+g17
+sg7
+I5
+sg8
+(S'password'
+S'kjh45fDf_'
+tp96
+saa(lp97
+(dp98
+g4
+I32
+sg5
+g17
+sg7
+I5
+sg8
+(S'mutual_userid'
+S'no'
+tp99
+saa(lp100
+(dp101
+g4
+I33
+sg5
+g17
+sg7
+I5
+sg8
+(S'mutual_password'
+S'no'
+tp102
+saasg4
+I28
+sg5
+g52
+sg7
+I29
+saa(lp103
+(dp104
+g4
+I36
+sg5
+g6
+sg7
+I1
+sg8
+(S'fabric'
+S'iscsi'
+tp105
+sa(dp106
+g13
+(lp107
+(lp108
+(dp109
+g4
+I37
+sg5
+g6
+sg7
+I5
+sg8
+(S'target'
+S'iqn.2003-01.org.linux-iscsi.targetcli.x8664:sn.4699f8812c88'
+tp110
+sa(dp111
+g13
+(lp112
+(lp113
+(dp114
+g4
+I38
+sg5
+g6
+sg7
+I9
+sg8
+(S'tpgt'
+S'1'
+tp115
+sa(dp116
+g13
+(lp117
+(lp118
+(dp119
+g4
+I39
+sg5
+g6
+sg7
+I13
+sg8
+(S'lun'
+S'1'
+tp120
+sa(dp121
+g4
+I39
+sg5
+g17
+sg7
+I19
+sg8
+(S'backend'
+S'fileio:disk1'
+tp122
+saa(lp123
+(dp124
+g4
+I40
+sg5
+g6
+sg7
+I13
+sg8
+(S'lun'
+S'2'
+tp125
+sa(dp126
+g4
+I40
+sg5
+g17
+sg7
+I19
+sg8
+(S'backend'
+S'fileio:disk2'
+tp127
+saa(lp128
+(dp129
+g4
+I41
+sg5
+g6
+sg7
+I13
+sg8
+(S'portal'
+S'0.0.0.0:3260'
+tp130
+saa(lp131
+(dp132
+g4
+I43
+sg5
+g24
+sg7
+I13
+sg8
+(S'attribute'
+tp133
+sa(dp134
+g13
+(lp135
+(lp136
+(dp137
+g4
+I44
+sg5
+g17
+sg7
+I17
+sg8
+(S'authentication'
+S'no'
+tp138
+saa(lp139
+(dp140
+g4
+I45
+sg5
+g17
+sg7
+I17
+sg8
+(S'cache_dynamic_acls'
+S'no'
+tp141
+saa(lp142
+(dp143
+g4
+I46
+sg5
+g17
+sg7
+I17
+sg8
+(S'default_cmdsn_depth'
+S'16'
+tp144
+saa(lp145
+(dp146
+g4
+I47
+sg5
+g17
+sg7
+I17
+sg8
+(S'demo_mode_write_protect'
+S'no'
+tp147
+saa(lp148
+(dp149
+g4
+I48
+sg5
+g17
+sg7
+I17
+sg8
+(S'generate_node_acls'
+S'no'
+tp150
+saa(lp151
+(dp152
+g4
+I49
+sg5
+g17
+sg7
+I17
+sg8
+(S'login_timeout'
+S'15'
+tp153
+saa(lp154
+(dp155
+g4
+I50
+sg5
+g17
+sg7
+I17
+sg8
+(S'netif_timeout'
+S'2'
+tp156
+saa(lp157
+(dp158
+g4
+I51
+sg5
+g17
+sg7
+I17
+sg8
+(S'prod_mode_write_protect'
+S'no'
+tp159
+saasg4
+I43
+sg5
+g52
+sg7
+I23
+saa(lp160
+(dp161
+g4
+I54
+sg5
+g24
+sg7
+I13
+sg8
+(S'parameter'
+tp162
+sa(dp163
+g13
+(lp164
+(lp165
+(dp166
+g4
+I55
+sg5
+g17
+sg7
+I17
+sg8
+(S'MaxConnections'
+S'12'
+tp167
+saa(lp168
+(dp169
+g4
+I56
+sg5
+g17
+sg7
+I17
+sg8
+(S'MaxOutstandingR2T'
+S'34'
+tp170
+saa(lp171
+(dp172
+g4
+I57
+sg5
+g17
+sg7
+I17
+sg8
+(S'TargetAlias'
+S'LIO Target'
+tp173
+saa(lp174
+(dp175
+g4
+I58
+sg5
+g17
+sg7
+I17
+sg8
+(S'AuthMethod'
+S'CHAP'
+tp176
+saa(lp177
+(dp178
+g4
+I59
+sg5
+g17
+sg7
+I17
+sg8
+(S'ImmediateData'
+S'yes'
+tp179
+saa(lp180
+(dp181
+g4
+I60
+sg5
+g17
+sg7
+I17
+sg8
+(S'MaxBurstLength'
+S'262144'
+tp182
+saa(lp183
+(dp184
+g4
+I61
+sg5
+g17
+sg7
+I17
+sg8
+(S'MaxRecvDataSegmentLength'
+S'8192'
+tp185
+saa(lp186
+(dp187
+g4
+I62
+sg5
+g17
+sg7
+I17
+sg8
+(S'HeaderDigest'
+S'CRC32C,None'
+tp188
+saa(lp189
+(dp190
+g4
+I63
+sg5
+g17
+sg7
+I17
+sg8
+(S'OFMarker'
+S'no'
+tp191
+saasg4
+I54
+sg5
+g52
+sg7
+I23
+saa(lp192
+(dp193
+g4
+I66
+sg5
+g6
+sg7
+I13
+sg8
+(S'acl'
+S'iqn.2003-01.org.linux-iscsi.targetcli.x8664:client1'
+tp194
+sa(dp195
+g13
+(lp196
+(lp197
+(dp198
+g4
+I67
+sg5
+g24
+sg7
+I17
+sg8
+(S'attribute'
+tp199
+sa(dp200
+g13
+(lp201
+(lp202
+(dp203
+g4
+I68
+sg5
+g17
+sg7
+I21
+sg8
+(S'dataout_timeout'
+S'3'
+tp204
+saa(lp205
+(dp206
+g4
+I69
+sg5
+g17
+sg7
+I21
+sg8
+(S'dataout_timeout_retries'
+S'5'
+tp207
+saa(lp208
+(dp209
+g4
+I70
+sg5
+g17
+sg7
+I21
+sg8
+(S'default_erl'
+S'0'
+tp210
+saa(lp211
+(dp212
+g4
+I71
+sg5
+g17
+sg7
+I21
+sg8
+(S'nopin_response_timeout'
+S'30'
+tp213
+saa(lp214
+(dp215
+g4
+I72
+sg5
+g17
+sg7
+I21
+sg8
+(S'nopin_timeout'
+S'15'
+tp216
+saa(lp217
+(dp218
+g4
+I73
+sg5
+g17
+sg7
+I21
+sg8
+(S'random_datain_pdu_offsets'
+S'no'
+tp219
+saa(lp220
+(dp221
+g4
+I74
+sg5
+g17
+sg7
+I21
+sg8
+(S'random_datain_seq_offsets'
+S'no'
+tp222
+saa(lp223
+(dp224
+g4
+I75
+sg5
+g17
+sg7
+I21
+sg8
+(S'random_r2t_offsets'
+S'no'
+tp225
+saasg4
+I67
+sg5
+g52
+sg7
+I27
+saa(lp226
+(dp227
+g4
+I77
+sg5
+g24
+sg7
+I17
+sg8
+(S'auth'
+tp228
+sa(dp229
+g13
+(lp230
+(lp231
+(dp232
+g4
+I78
+sg5
+g17
+sg7
+I21
+sg8
+(S'userid'
+S'jerome'
+tp233
+saa(lp234
+(dp235
+g4
+I79
+sg5
+g17
+sg7
+I21
+sg8
+(S'password'
+S'foobar'
+tp236
+saa(lp237
+(dp238
+g4
+I80
+sg5
+g17
+sg7
+I21
+sg8
+(S'userid_mutual'
+S'just_the2ofus'
+tp239
+saa(lp240
+(dp241
+g4
+I81
+sg5
+g17
+sg7
+I21
+sg8
+(S'password_mutual'
+S'mutupass'
+tp242
+saasg4
+I77
+sg5
+g52
+sg7
+I22
+saa(lp243
+(dp244
+g4
+I83
+sg5
+g6
+sg7
+I17
+sg8
+(S'mapped_lun'
+S'1'
+tp245
+sa(dp246
+g4
+I83
+sg5
+g17
+sg7
+I30
+sg8
+(S'target_lun'
+S'1'
+tp247
+saa(lp248
+(dp249
+g4
+I84
+sg5
+g6
+sg7
+I17
+sg8
+(S'mapped_lun'
+S'2'
+tp250
+sa(dp251
+g4
+I84
+sg5
+g17
+sg7
+I30
+sg8
+(S'target_lun'
+S'1'
+tp252
+saa(lp253
+(dp254
+g4
+I85
+sg5
+g6
+sg7
+I17
+sg8
+(S'mapped_lun'
+S'3'
+tp255
+sa(dp256
+g4
+I85
+sg5
+g17
+sg7
+I30
+sg8
+(S'target_lun'
+S'1'
+tp257
+saasg4
+I66
+sg5
+g52
+sg7
+I71
+saasg4
+I38
+sg5
+g52
+sg7
+I16
+saasg4
+I37
+sg5
+g52
+sg7
+I74
+saasg4
+I36
+sg5
+g52
+sg7
+I14
+saa.
diff --git a/tests/data/config_complete.lio b/tests/data/config_complete.lio
new file mode 100644
index 0000000..c287271
--- /dev/null
+++ b/tests/data/config_complete.lio
@@ -0,0 +1,89 @@
+storage fileio disk disk1 {
+    path /tmp/disk1.img
+    size 1MB
+
+    attribute {
+        block_size 512
+        optimal_sectors 1024
+        queue_depth 32
+
+        emulate_tas yes
+        enforce_pr_isids yes
+
+        emulate_dpo no
+        emulate_tpu no
+        is_nonrot no
+  }
+}
+
+storage fileio disk disk2 {
+    path /tmp/disk2.img
+    size 1M
+    attribute block_size 512
+    attribute optimal_sectors 1024
+    attribute queue_depth 32
+}
+
+
+fabric iscsi discovery_auth {
+    enable yes
+    userid "target1"
+    password "kjh45fDf_"
+    mutual_userid no
+    mutual_password no
+}
+
+fabric iscsi {
+    target "iqn.2003-01.org.linux-iscsi.targetcli.x8664:sn.4699f8812c88" {
+        tpgt 1 {
+            lun 1 backend fileio:disk1
+            lun 2 backend fileio:disk2
+            portal 0.0.0.0:3260
+
+            attribute {
+                authentication no
+                cache_dynamic_acls no
+                default_cmdsn_depth 16
+                demo_mode_write_protect no
+                generate_node_acls no
+                login_timeout 15
+                netif_timeout 2
+                prod_mode_write_protect no
+            }
+
+            parameter {
+                MaxConnections 12
+                MaxOutstandingR2T 34
+                TargetAlias "LIO Target"
+                AuthMethod "CHAP"
+                ImmediateData yes
+                MaxBurstLength 262144
+                MaxRecvDataSegmentLength 8192
+                HeaderDigest "CRC32C,None"
+                OFMarker no
+            }
+
+            acl "iqn.2003-01.org.linux-iscsi.targetcli.x8664:client1" {
+                attribute {
+                    dataout_timeout 3
+                    dataout_timeout_retries 5
+                    default_erl 0
+                    nopin_response_timeout 30
+                    nopin_timeout 15
+                    random_datain_pdu_offsets no
+                    random_datain_seq_offsets no
+                    random_r2t_offsets no
+                }
+                auth {
+                    userid jerome
+                    password foobar
+                    userid_mutual just_the2ofus
+                    password_mutual mutupass
+                }
+                mapped_lun 1 target_lun 1
+                mapped_lun 2 target_lun 1
+                mapped_lun 3 target_lun 1
+            }
+        }
+    }
+}
diff --git a/tests/data/config_invalid_reference.lio b/tests/data/config_invalid_reference.lio
new file mode 100644
index 0000000..117380b
--- /dev/null
+++ b/tests/data/config_invalid_reference.lio
@@ -0,0 +1,89 @@
+storage fileio disk disk1 {
+    path /tmp/disk1.img
+    size 1MB
+
+    attribute {
+        block_size 512
+        optimal_sectors 1024
+        queue_depth 32
+
+        emulate_tas yes
+        enforce_pr_isids yes
+
+        emulate_dpo no
+        emulate_tpu no
+        is_nonrot no
+  }
+}
+
+storage fileio disk disk2 {
+    path /tmp/disk2.img
+    size 1M
+    attribute block_size 512
+    attribute optimal_sectors 1024
+    attribute queue_depth 32
+}
+
+
+fabric iscsi discovery_auth {
+    enable yes
+    userid "target1"
+    password "kjh45fDf_"
+    mutual_userid no
+    mutual_password no
+}
+    
+fabric iscsi {
+    target "iqn.2003-01.org.linux-iscsi.targetcli.x8664:sn.4699f8812c88" {
+        tpgt 1 {
+            lun 1 backend fileio:disk3
+            lun 2 backend fileio:disk2
+            portal 0.0.0.0:3260
+
+            attribute {
+                authentication no
+                cache_dynamic_acls no
+                default_cmdsn_depth 16
+                demo_mode_write_protect no
+                generate_node_acls no
+                login_timeout 15
+                netif_timeout 2
+                prod_mode_write_protect no
+            }
+
+            parameter {
+                MaxConnections 12
+                MaxOutstandingR2T 34
+                TargetAlias "LIO Target"
+                AuthMethod "CHAP"
+                ImmediateData yes
+                MaxBurstLength 262144
+                MaxRecvDataSegmentLength 8192
+                HeaderDigest "CRC32C,None"
+                OFMarker no
+            }
+
+            acl "iqn.2003-01.org.linux-iscsi.targetcli.x8664:client1" {
+                attribute {
+                    dataout_timeout 3 
+                    dataout_timeout_retries 5 
+                    default_erl no 
+                    nopin_response_timeout 30 
+                    nopin_timeout 15 
+                    random_datain_pdu_offsets no 
+                    random_datain_seq_offsets no 
+                    random_r2t_offsets no 
+                }
+                auth {
+                    userid jerome
+                    password foobar 
+                    userid_mutual just_the2ofus 
+                    password_mutual mutupass 
+                }
+                lun 1 target_lun 1
+                lun 2 target_lun 1 
+                lun 3 target_lun 1 
+            }
+        }
+    }
+}
diff --git a/tests/data/config_nested_blocks.ast b/tests/data/config_nested_blocks.ast
new file mode 100644
index 0000000..93b0713
--- /dev/null
+++ b/tests/data/config_nested_blocks.ast
@@ -0,0 +1,218 @@
+(lp0
+(lp1
+(dp2
+S'line'
+p3
+I1
+sS'type'
+p4
+S'obj'
+p5
+sS'col'
+p6
+I1
+sS'key'
+p7
+(S'storage'
+p8
+S'fileio'
+p9
+tp10
+sa(dp11
+S'statements'
+p12
+(lp13
+(lp14
+(dp15
+g3
+I2
+sg4
+g5
+sg6
+I5
+sg7
+(S'disk'
+p16
+S'vm1'
+p17
+tp18
+sa(dp19
+g12
+(lp20
+(lp21
+(dp22
+g3
+I3
+sg4
+S'attr'
+p23
+sg6
+I9
+sg7
+(S'path'
+p24
+S'/tmp/disk1.img'
+p25
+tp26
+saa(lp27
+(dp28
+g3
+I4
+sg4
+g23
+sg6
+I9
+sg7
+(S'size'
+p29
+S'1MB'
+p30
+tp31
+saa(lp32
+(dp33
+g3
+I6
+sg4
+S'group'
+p34
+sg6
+I9
+sg7
+(S'attribute'
+p35
+tp36
+sa(dp37
+g12
+(lp38
+(lp39
+(dp40
+g3
+I7
+sg4
+g23
+sg6
+I13
+sg7
+(S'block_size'
+p41
+S'512'
+p42
+tp43
+saa(lp44
+(dp45
+g3
+I8
+sg4
+g23
+sg6
+I13
+sg7
+(S'optimal_sectors'
+p46
+S'1024'
+p47
+tp48
+saa(lp49
+(dp50
+g3
+I9
+sg4
+g23
+sg6
+I13
+sg7
+(S'queue_depth'
+p51
+S'32'
+p52
+tp53
+saa(lp54
+(dp55
+g3
+I11
+sg4
+g23
+sg6
+I13
+sg7
+(S'emulate_tas'
+p56
+S'yes'
+p57
+tp58
+saa(lp59
+(dp60
+g3
+I12
+sg4
+g23
+sg6
+I13
+sg7
+(S'enforce_pr_isids'
+p61
+S'yes'
+p62
+tp63
+saa(lp64
+(dp65
+g3
+I14
+sg4
+g23
+sg6
+I13
+sg7
+(S'emulate_dpo'
+p66
+S'no'
+p67
+tp68
+saa(lp69
+(dp70
+g3
+I15
+sg4
+g23
+sg6
+I13
+sg7
+(S'emulate_tpu'
+p71
+S'no'
+p72
+tp73
+saa(lp74
+(dp75
+g3
+I16
+sg4
+g23
+sg6
+I13
+sg7
+(S'is_nonrot'
+p76
+S'no'
+p77
+tp78
+saasg3
+I6
+sg4
+S'block'
+p79
+sg6
+I19
+saasg3
+I2
+sg4
+g79
+sg6
+I14
+saasg3
+I1
+sg4
+g79
+sg6
+I16
+saa.
\ No newline at end of file
diff --git a/tests/data/config_nested_blocks.lio b/tests/data/config_nested_blocks.lio
new file mode 100644
index 0000000..85117af
--- /dev/null
+++ b/tests/data/config_nested_blocks.lio
@@ -0,0 +1,19 @@
+storage fileio {
+    disk vm1 {
+        path /tmp/disk1.img
+        size 1MB
+
+        attribute {
+            block_size 512
+            optimal_sectors 1024
+            queue_depth 32
+
+            emulate_tas yes
+            enforce_pr_isids yes
+
+            emulate_dpo no
+            emulate_tpu no
+            is_nonrot no
+        }
+    }
+}
diff --git a/tests/data/config_one_line.ast b/tests/data/config_one_line.ast
new file mode 100644
index 0000000..304fd7f
--- /dev/null
+++ b/tests/data/config_one_line.ast
@@ -0,0 +1,47 @@
+(lp0
+(lp1
+(dp2
+S'line'
+p3
+I1
+sS'type'
+p4
+S'obj'
+p5
+sS'col'
+p6
+I1
+sS'key'
+p7
+(S'fabric'
+p8
+S'iscsi'
+p9
+tp10
+sa(dp11
+g3
+I1
+sg4
+S'group'
+p12
+sg6
+I14
+sg7
+(S'discovery_auth'
+p13
+tp14
+sa(dp15
+g3
+I1
+sg4
+S'attr'
+p16
+sg6
+I29
+sg7
+(S'enable'
+p17
+S'yes'
+p18
+tp19
+saa.
\ No newline at end of file
diff --git a/tests/data/config_one_line.lio b/tests/data/config_one_line.lio
new file mode 100644
index 0000000..8347352
--- /dev/null
+++ b/tests/data/config_one_line.lio
@@ -0,0 +1 @@
+fabric iscsi discovery_auth enable yes
diff --git a/tests/data/config_ramdisk_fileio_iscsi.lio b/tests/data/config_ramdisk_fileio_iscsi.lio
new file mode 100644
index 0000000..002f45d
--- /dev/null
+++ b/tests/data/config_ramdisk_fileio_iscsi.lio
@@ -0,0 +1,194 @@
+storage fileio disk disk1 {
+    path /tmp/disk1.img
+    size 1.0M
+    buffered yes
+    attribute block_size 512
+    attribute emulate_dpo 0
+    attribute emulate_fua_read 0
+    attribute emulate_fua_write 1
+    attribute emulate_rest_reord 0
+    attribute emulate_tas 1
+    attribute emulate_tpu 0
+    attribute emulate_tpws 0
+    attribute emulate_ua_intlck_ctrl 0
+    attribute emulate_write_cache 0
+    attribute enforce_pr_isids 1
+    attribute is_nonrot 0
+    attribute max_unmap_block_desc_count 0
+    attribute max_unmap_lba_count 0
+    attribute optimal_sectors 1024
+    attribute queue_depth 32
+    attribute unmap_granularity 0
+    attribute unmap_granularity_alignment 0
+}
+
+storage fileio disk disk2 {
+    path /tmp/disk2.img
+    size 1.0M
+    buffered yes
+    attribute block_size 512
+    attribute emulate_dpo 0
+    attribute emulate_fua_read 0
+    attribute emulate_fua_write 1
+    attribute emulate_rest_reord 0
+    attribute emulate_tas 1
+    attribute emulate_tpu 0
+    attribute emulate_tpws 0
+    attribute emulate_ua_intlck_ctrl 0
+    attribute emulate_write_cache 0
+    attribute enforce_pr_isids 1
+    attribute is_nonrot 0
+    attribute max_unmap_block_desc_count 0
+    attribute max_unmap_lba_count 0
+    attribute optimal_sectors 1024
+    attribute queue_depth 32
+    attribute unmap_granularity 0
+    attribute unmap_granularity_alignment 0
+}
+
+storage rd_mcp disk test {
+    size 1.0M
+    attribute block_size 512
+    attribute emulate_dpo 0
+    attribute emulate_fua_read 0
+    attribute emulate_fua_write 1
+    attribute emulate_rest_reord 0
+    attribute emulate_tas 1
+    attribute emulate_tpu 0
+    attribute emulate_tpws 0
+    attribute emulate_ua_intlck_ctrl 0
+    attribute emulate_write_cache 0
+    attribute enforce_pr_isids 1
+    attribute is_nonrot 0
+    attribute max_unmap_block_desc_count 0
+    attribute max_unmap_lba_count 0
+    attribute optimal_sectors 1024
+    attribute queue_depth 32
+    attribute unmap_granularity 0
+    attribute unmap_granularity_alignment 0
+}
+
+storage rd_mcp disk test2 {
+    size 1.0M
+    attribute block_size 512
+    attribute emulate_dpo 0
+    attribute emulate_fua_read 0
+    attribute emulate_fua_write 1
+    attribute emulate_rest_reord 0
+    attribute emulate_tas 1
+    attribute emulate_tpu 0
+    attribute emulate_tpws 0
+    attribute emulate_ua_intlck_ctrl 0
+    attribute emulate_write_cache 0
+    attribute enforce_pr_isids 1
+    attribute is_nonrot 0
+    attribute max_unmap_block_desc_count 0
+    attribute max_unmap_lba_count 0
+    attribute optimal_sectors 1024
+    attribute queue_depth 32
+    attribute unmap_granularity 0
+    attribute unmap_granularity_alignment 0
+}
+
+fabric iscsi {
+    discovery_auth enable 1
+    discovery_auth userid target1
+    discovery_auth password kjh45fDf_
+    discovery_auth mutual_userid no
+    discovery_auth mutual_password no
+}
+
+fabric iscsi target iqn.2003-01.org.linux-iscsi.targetcli.x8664:sn.4699f8812c88 tpgt 1 {
+    attribute authentication 0
+    attribute cache_dynamic_acls 0
+    attribute default_cmdsn_depth 16
+    attribute demo_mode_write_protect 0
+    attribute generate_node_acls 0
+    attribute login_timeout 15
+    attribute netif_timeout 2
+    attribute prod_mode_write_protect 0
+    parameter AuthMethod CHAP
+    parameter DataDigest "CRC32C,None"
+    parameter DataPDUInOrder Yes
+    parameter DataSequenceInOrder Yes
+    parameter DefaultTime2Retain 20
+    parameter DefaultTime2Wait 2
+    parameter ErrorRecoveryLevel No
+    parameter FirstBurstLength 65536
+    parameter HeaderDigest "CRC32C,None"
+    parameter IFMarkInt "2048~65535"
+    parameter IFMarker No
+    parameter ImmediateData Yes
+    parameter InitialR2T Yes
+    parameter MaxBurstLength 262144
+    parameter MaxConnections 12
+    parameter MaxOutstandingR2T 34
+    parameter MaxRecvDataSegmentLength 8192
+    parameter OFMarkInt "2048~65535"
+    parameter OFMarker No
+    parameter TargetAlias "LIO Target"
+    lun 1 backend fileio:disk1
+    lun 2 backend fileio:disk2
+    acl iqn.2003-01.org.linux-iscsi.targetcli.x8664:client1 {
+        attribute dataout_timeout 3
+        attribute dataout_timeout_retries 5
+        attribute default_erl 0
+        attribute nopin_response_timeout 30
+        attribute nopin_timeout 15
+        attribute random_datain_pdu_offsets 0
+        attribute random_datain_seq_offsets 0
+        attribute random_r2t_offsets 0
+        auth password foobar
+        auth password_mutual mutupass
+        auth userid jerome
+        auth userid_mutual just_the2ofus
+        mapped_lun 1 {
+             target_lun 1
+             write_protect 0
+        }
+        mapped_lun 2 {
+             target_lun 1
+             write_protect 0
+        }
+        mapped_lun 3 {
+             target_lun 1
+             write_protect 0
+        }
+    }
+    portal 0.0.0.0:3260
+    enable 1
+}
+
+fabric iscsi target iqn.2003-01.org.linux-iscsi.targetcli.x8664:sn.caa307436d89 tpgt 1 {
+    attribute authentication 1
+    attribute cache_dynamic_acls 0
+    attribute default_cmdsn_depth 16
+    attribute demo_mode_write_protect 1
+    attribute generate_node_acls 0
+    attribute login_timeout 15
+    attribute netif_timeout 2
+    attribute prod_mode_write_protect 0
+    parameter AuthMethod CHAP
+    parameter DataDigest "CRC32C,None"
+    parameter DataPDUInOrder Yes
+    parameter DataSequenceInOrder Yes
+    parameter DefaultTime2Retain 20
+    parameter DefaultTime2Wait 2
+    parameter ErrorRecoveryLevel 0
+    parameter FirstBurstLength 65536
+    parameter HeaderDigest "CRC32C,None"
+    parameter IFMarkInt "2048~65535"
+    parameter IFMarker No
+    parameter ImmediateData Yes
+    parameter InitialR2T Yes
+    parameter MaxBurstLength 262144
+    parameter MaxConnections 1
+    parameter MaxOutstandingR2T 1
+    parameter MaxRecvDataSegmentLength 8192
+    parameter OFMarkInt "2048~65535"
+    parameter OFMarker No
+    parameter TargetAlias "LIO Target"
+    lun 0 backend rd_mcp:test
+    lun 1 backend rd_mcp:test2
+    enable 1
+}
diff --git a/tests/data/config_sample_1.lio b/tests/data/config_sample_1.lio
new file mode 100644
index 0000000..c7b16c0
--- /dev/null
+++ b/tests/data/config_sample_1.lio
@@ -0,0 +1,224 @@
+storage fileio disk test {
+    buffered no 
+    path /tmp/test.img 
+    size 1.0MB 
+    attribute {
+        block_size 512 
+        emulate_3pc yes 
+        emulate_caw yes 
+        emulate_dpo no 
+        emulate_fua_read no 
+        emulate_fua_write yes 
+        emulate_model_alias no 
+        emulate_rest_reord no 
+        emulate_tas yes 
+        emulate_tpu no 
+        emulate_tpws no 
+        emulate_ua_intlck_ctrl no 
+        emulate_write_cache no 
+        enforce_pr_isids yes 
+        fabric_max_sectors 8192 
+        is_nonrot no 
+        max_unmap_block_desc_count 1 
+        max_unmap_lba_count 8192 
+        max_write_same_len 4096 
+        optimal_sectors 8192 
+        queue_depth 128 
+        unmap_granularity 1 
+        unmap_granularity_alignment 0 
+    }
+}
+storage rd_mcp {
+    disk test {
+        nullio no 
+        size 10.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write no 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache no 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count no 
+            max_unmap_lba_count no 
+            max_write_same_len 0 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity no 
+            unmap_granularity_alignment no 
+        }
+    }
+    disk test2 {
+        nullio no 
+        size 10.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache no 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count no 
+            max_unmap_lba_count no 
+            max_write_same_len 0 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity no 
+            unmap_granularity_alignment no 
+        }
+    }
+    disk test3 {
+        nullio no 
+        size 10.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache no 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count no 
+            max_unmap_lba_count no 
+            max_write_same_len 0 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity no 
+            unmap_granularity_alignment no 
+        }
+    }
+    disk test_nullio {
+        nullio yes 
+        size 10.0MB 
+        attribute {
+            block_size 512 
+            emulate_3pc yes 
+            emulate_caw yes 
+            emulate_dpo no 
+            emulate_fua_read no 
+            emulate_fua_write yes 
+            emulate_model_alias no 
+            emulate_rest_reord no 
+            emulate_tas yes 
+            emulate_tpu no 
+            emulate_tpws no 
+            emulate_ua_intlck_ctrl no 
+            emulate_write_cache no 
+            enforce_pr_isids yes 
+            fabric_max_sectors 8192 
+            is_nonrot no 
+            max_unmap_block_desc_count no 
+            max_unmap_lba_count no 
+            max_write_same_len 0 
+            optimal_sectors 8192 
+            queue_depth 128 
+            unmap_granularity no 
+            unmap_granularity_alignment no 
+        }
+    }
+}
+fabric iscsi {
+    discovery_auth {
+        enable no 
+        mutual_password "" 
+        mutual_userid "" 
+        password "" 
+        userid "" 
+    }
+    target iqn.2003-01.org.linux-iscsi.ws0.x8664:sn.690f8dd50f79 tpgt 1 {
+        enable yes 
+        attribute {
+            authentication yes 
+            cache_dynamic_acls no 
+            default_cmdsn_depth 64 
+            default_erl 0 
+            demo_mode_discovery yes 
+            demo_mode_write_protect yes 
+            generate_node_acls no 
+            login_timeout 15 
+            netif_timeout 2 
+            prod_mode_write_protect no 
+        }
+        auth {
+            password "" 
+            password_mutual "" 
+            userid "" 
+            userid_mutual "" 
+        }
+        parameter {
+            AuthMethod CHAP 
+            DataDigest "CRC32C,None" 
+            DataPDUInOrder yes 
+            DataSequenceInOrder yes 
+            DefaultTime2Retain 20 
+            DefaultTime2Wait 2 
+            ErrorRecoveryLevel no 
+            FirstBurstLength 65536 
+            HeaderDigest "CRC32C,None" 
+            IFMarkInt "2048~65535" 
+            IFMarker no 
+            ImmediateData yes 
+            InitialR2T yes 
+            MaxBurstLength 262144 
+            MaxConnections 1 
+            MaxOutstandingR2T 1 
+            MaxRecvDataSegmentLength 8192 
+            MaxXmitDataSegmentLength 262144 
+            OFMarkInt "2048~65535" 
+            OFMarker no 
+            TargetAlias "LIO Target" 
+        }
+        lun 0 backend fileio:test 
+        acl iqn.2003-01.org.linux-iscsi.ws0.x8664:client1 {
+            attribute {
+                dataout_timeout 3 
+                dataout_timeout_retries 5 
+                default_erl 0 
+                nopin_response_timeout 30 
+                nopin_timeout 15 
+                random_datain_pdu_offsets no 
+                random_datain_seq_offsets no 
+                random_r2t_offsets no 
+            }
+            auth {
+                password "" 
+                password_mutual "" 
+                userid "" 
+                userid_mutual "" 
+            }
+            mapped_lun 0 {
+                target_lun 0 
+                write_protect no 
+            }
+        }
+    }
+}
